from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

import sys
import random

Global_Map = []
Global_Spawns = []
Global_X = 10
Global_Y = 15

TYPE_TREE = 1
TYPE_WALL = 2
TYPE_SPAWN = 3
TYPE_DESTINATION = 4
TYPE_COCOTREE = 5
TYPE_GRASS = 6
TYPE_WALL1 = 7

ORIGIN_XOFFSET = 20
ORIGIN_YOFFSET = 20

CUR_TYPE = TYPE_TREE

width = 640
height = 480

def display( ):
	global CUR_TYPE
	glClear( GL_COLOR_BUFFER_BIT )
	glColor3f( 1, 1, 1 )

	glBegin( GL_LINES )
	for i in range(60):
		glVertex2i( i*10, 0 )
		glVertex2i( i*10, 10*30)
	glEnd( )

	glBegin( GL_LINES )
	for i in range(30):
		glVertex2i( 0, i*10 )
		glVertex2i( 60*10, i*10 )
	glEnd( )	
	
	for i in range( 60 ):
		for j in range( 30 ):
			if Global_Map[i][j] == TYPE_TREE:
				glColor3f( 0, 1, 0 )
			elif Global_Map[i][j] == TYPE_COCOTREE:
				glColor3f( 0.28, 1, 0 )
			elif Global_Map[i][j] == TYPE_GRASS:
				glColor3f( .5, 1, .5 )
			elif Global_Map[i][j] == TYPE_SPAWN:
				glColor3f( 1, 0 , 0 )
			elif Global_Map[i][j] == TYPE_DESTINATION:
				glColor3f( 0, 0, 1 )
			elif Global_Map[i][j] == TYPE_WALL:
				glColor3f( .28, .28, .28 )
			elif Global_Map[i][j] == TYPE_WALL1:
				glColor3f( 1, 1, .28 )

			if( not(Global_Map[i][j] == 0) ):
				glBegin( GL_POLYGON )
				glVertex2i( i*10, j*10 )
				glVertex2i( i*10+10, j*10 )
				glVertex2i( i*10+10, j*10+10 )
				glVertex2i( i*10, j*10+10 )
				glEnd( )


	glutSwapBuffers( )

def saveMap( ):
	global Global_Spawns
	fp = open( "map.txt", "w" )

	fp.write( "wood "+random.choice(['500','600', '300'])+"\n" )
	fp.write( "cops " + random.choice(['40','20','30'])+"\n" )
	fp.write( "maxcops "+random.choice(['10', '15', '6'])+"\n" )
	fp.write( "spawns "+str(len(Global_Spawns))+"\n")
	for i  in range( len(Global_Spawns) ):
		fp.write( str(Global_Spawns[i][0])+" "+str(Global_Spawns[i][1])+"\n" )
	fp.write( str(len(Global_Map))+"\n")
	fp.write( str(len(Global_Map[0]))+"\n")

	for i in range( len(Global_Map) ):
		for j in range( len( Global_Map[i] ) ):
			fp.write( str(Global_Map[i][j])+" " )
		fp.write("\n")

	fp.close( )

def keyboard( key, x, y ):
	global CUR_TYPE
	if key == '1':
		CUR_TYPE = TYPE_TREE
		print "Place Trees"
	if key == '2':
		CUR_TYPE =TYPE_COCOTREE
		print "Place Coco Trees"
	elif key =='3':
		CUR_TYPE = TYPE_GRASS
		print "Place Grass"
	elif key == 's':
		CUR_TYPE = TYPE_SPAWN
		print "Place Spawn positions"
	elif key == 'w':
		CUR_TYPE = TYPE_WALL
		print "Place Wall around"
	elif key == 'e':
		CUR_TYPE = TYPE_WALL1
		print "Place Wall1"
	elif key == 'd':
		CUR_TYPE = TYPE_DESTINATION
		print "Destination Point"
	elif key == 'c':
		CUR_TYPE = 0
		print "Cleaning"
	elif key == 'q':
		saveMap( )
		sys.exit(0)

def mouseFunc( x, y ):
	global CUR_TYPE
	global Global_Spawns

	xpos = x/10
	ypos = (height-y)/10
#	print xpos, ypos, CUR_TYPE
	Global_Map[xpos][ypos] = CUR_TYPE
	if CUR_TYPE == TYPE_SPAWN:
		Global_Spawns.append( (xpos,ypos) )

def init( ):
	for i in range(60):
		Global_Map.append([])
		for j in range(30):
			Global_Map[i].append(0)

	glClearColor( 0, 0, 0, 0 )
	glMatrixMode( GL_PROJECTION )
	glLoadIdentity( )
	gluOrtho2D( 0, width, 0, height )
	glViewport( 0, 0, width, height )
	glMatrixMode( GL_MODELVIEW )
	glLoadIdentity( )

if __name__=="__main__":
	glutInit( sys.argv )
	glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE )
	glutInitWindowSize( width, height )
	glutCreateWindow( "MAP EDITOR" )
	init( )
	glutDisplayFunc( display )
	glutIdleFunc( display )
	glutMotionFunc( mouseFunc )
	glutKeyboardFunc( keyboard )
	glutMainLoop()
	
