from OpenGL.GL import *
from OpenGL.GLU import *

import math
import random
import sys
import os

import mytexture

class elem:
	x = y = z = 0;
	dx = dy = dz = 0;
	size = 0;
	ts = 0;
	opacity = 0;

	def __init__(self):
		self.texid = None
		self.dx = random.randrange(2);
		self.dy = random.randrange(2);
		self.dz = random.randrange(2);
	
class Smoke:
	ox = oy = oz = 0;
	dx = dy = dz = 0;
	elems = [];
	intensity = 1;
	min_size = 0.2;
	max_size = 1.0;
	texture = 0;

	def __init__(self, x, y, z, dx, dy, dz, elems, intensity, texName ):
		self.ox = x;
		self.oy = y;
		self.oz = z;
		self.dx = dx;
		self.dy = dy;
		self.dz = dz;
		self.intesity = intensity;
		self.texture = mytexture.loadTexture(texName);
		for i in xrange(elems):
			tmp = elem();
			tmp.ts = i/float(elems);
			self.elems.append(tmp);

	def render(self):
		glDepthMask(0);
		glEnable( GL_TEXTURE_2D )
		glBindTexture(GL_TEXTURE_2D, self.texture);
		glEnable(GL_ALPHA_TEST);
		glEnable( GL_BLEND )
		for i in xrange(len(self.elems)):
			e = self.elems[i];
			glColor4f(self.intensity,self.intensity,self.intensity,e.opacity);
			glBegin(GL_QUADS);
			glTexCoord2f(0, 0); 
			glVertex3f(-1*e.size+e.x,-1*e.size+e.y, -0.+e.z);
			glTexCoord2f(0, 1); 
			glVertex3f(-1*e.size+e.x, 1*e.size+e.y,  0.+e.z);
			glTexCoord2f(1, 1);	
			glVertex3f( 1.*e.size+e.x, 1*e.size+e.y,  0.+e.z);
			glTexCoord2f(1, 0);	
			glVertex3f( 1.*e.size+e.x,-1.*e.size+e.y, -0.+e.z);
			glEnd();
		glDepthMask(1);
		glDisable( GL_BLEND )
		glDisable(GL_ALPHA_TEST);
		glDisable( GL_TEXTURE_2D )
	    
		
	def animate(self, tick ):
		for i in xrange(len(self.elems)):
			e = self.elems[i];
			e.ts += tick;
			if e.ts >= 1.0:
				e.ts = 0;
			e.x = float(self.ox + self.dx * e.ts + e.dx * e.ts);
			#e.x = float( e.dx * e.ts);
			e.y = float(self.dy * e.ts + e.dy * e.ts);
			#e.y = float( e.dy * e.ts);
			#e.z = float(self.oz + self.dz * e.ts + e.dz * e.ts);
			#e.z = float( e.dz * e.ts);
			e.size = float(self.min_size + e.ts * self.max_size);
			e.opacity = (1.0-e.ts);

